<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateSafCcdPurgeBlockLearnedRoutesReq StructType
 * @subpackage Structs
 */
class UpdateSafCcdPurgeBlockLearnedRoutesReq extends APIRequest
{
    /**
     * The uuid
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | learnedPattern | learnedPatternPrefix | callControlIdentity | ipAddress
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * The learnedPattern
     * Meta information extracted from the WSDL
     * - documentation: Either learnedPattern or learnedPatternPrefix has to be set
     * - base: xsd:string
     * - choice: uuid | learnedPattern | learnedPatternPrefix | callControlIdentity | ipAddress
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $learnedPattern;
    /**
     * The learnedPatternPrefix
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | learnedPattern | learnedPatternPrefix | callControlIdentity | ipAddress
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $learnedPatternPrefix;
    /**
     * The callControlIdentity
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | learnedPattern | learnedPatternPrefix | callControlIdentity | ipAddress
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $callControlIdentity;
    /**
     * The ipAddress
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - choice: uuid | learnedPattern | learnedPatternPrefix | callControlIdentity | ipAddress
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $ipAddress;
    /**
     * The newLearnedPattern
     * Meta information extracted from the WSDL
     * - documentation: Either learnedPattern or learnedPatternPrefix has to be set
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newLearnedPattern;
    /**
     * The newLearnedPatternPrefix
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newLearnedPatternPrefix;
    /**
     * The newCallControlIdentity
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newCallControlIdentity;
    /**
     * The newIpAddress
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $newIpAddress;
    /**
     * Constructor method for UpdateSafCcdPurgeBlockLearnedRoutesReq
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setUuid()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setLearnedPattern()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setLearnedPatternPrefix()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setCallControlIdentity()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setIpAddress()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setNewLearnedPattern()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setNewLearnedPatternPrefix()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setNewCallControlIdentity()
     * @uses UpdateSafCcdPurgeBlockLearnedRoutesReq::setNewIpAddress()
     * @param string $uuid
     * @param string $learnedPattern
     * @param string $learnedPatternPrefix
     * @param string $callControlIdentity
     * @param string $ipAddress
     * @param string $newLearnedPattern
     * @param string $newLearnedPatternPrefix
     * @param string $newCallControlIdentity
     * @param string $newIpAddress
     */
    public function __construct($uuid = null, $learnedPattern = null, $learnedPatternPrefix = null, $callControlIdentity = null, $ipAddress = null, $newLearnedPattern = null, $newLearnedPatternPrefix = null, $newCallControlIdentity = null, $newIpAddress = null)
    {
        $this
            ->setUuid($uuid)
            ->setLearnedPattern($learnedPattern)
            ->setLearnedPatternPrefix($learnedPatternPrefix)
            ->setCallControlIdentity($callControlIdentity)
            ->setIpAddress($ipAddress)
            ->setNewLearnedPattern($newLearnedPattern)
            ->setNewLearnedPatternPrefix($newLearnedPatternPrefix)
            ->setNewCallControlIdentity($newCallControlIdentity)
            ->setNewIpAddress($newIpAddress);
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return isset($this->uuid) ? $this->uuid : null;
    }
    /**
     * Set uuid value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $uuid
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setUuid($uuid = null)
    {
        if (is_null($uuid) || (is_array($uuid) && empty($uuid))) {
            unset($this->uuid);
        } else {
            $this->uuid = $uuid;
        }
        return $this;
    }
    /**
     * Get learnedPattern value
     * @return string|null
     */
    public function getLearnedPattern()
    {
        return isset($this->learnedPattern) ? $this->learnedPattern : null;
    }
    /**
     * Set learnedPattern value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $learnedPattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setLearnedPattern($learnedPattern = null)
    {
        if (is_null($learnedPattern) || (is_array($learnedPattern) && empty($learnedPattern))) {
            unset($this->learnedPattern);
        } else {
            $this->learnedPattern = $learnedPattern;
        }
        return $this;
    }
    /**
     * Get learnedPatternPrefix value
     * @return string|null
     */
    public function getLearnedPatternPrefix()
    {
        return isset($this->learnedPatternPrefix) ? $this->learnedPatternPrefix : null;
    }
    /**
     * Set learnedPatternPrefix value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $learnedPatternPrefix
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setLearnedPatternPrefix($learnedPatternPrefix = null)
    {
        if (is_null($learnedPatternPrefix) || (is_array($learnedPatternPrefix) && empty($learnedPatternPrefix))) {
            unset($this->learnedPatternPrefix);
        } else {
            $this->learnedPatternPrefix = $learnedPatternPrefix;
        }
        return $this;
    }
    /**
     * Get callControlIdentity value
     * @return string|null
     */
    public function getCallControlIdentity()
    {
        return isset($this->callControlIdentity) ? $this->callControlIdentity : null;
    }
    /**
     * Set callControlIdentity value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $callControlIdentity
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setCallControlIdentity($callControlIdentity = null)
    {
        if (is_null($callControlIdentity) || (is_array($callControlIdentity) && empty($callControlIdentity))) {
            unset($this->callControlIdentity);
        } else {
            $this->callControlIdentity = $callControlIdentity;
        }
        return $this;
    }
    /**
     * Get ipAddress value
     * @return string|null
     */
    public function getIpAddress()
    {
        return isset($this->ipAddress) ? $this->ipAddress : null;
    }
    /**
     * Set ipAddress value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param string $ipAddress
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setIpAddress($ipAddress = null)
    {
        if (is_null($ipAddress) || (is_array($ipAddress) && empty($ipAddress))) {
            unset($this->ipAddress);
        } else {
            $this->ipAddress = $ipAddress;
        }
        return $this;
    }
    /**
     * Get newLearnedPattern value
     * @return string|null
     */
    public function getNewLearnedPattern()
    {
        return $this->newLearnedPattern;
    }
    /**
     * Set newLearnedPattern value
     * @param string $newLearnedPattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setNewLearnedPattern($newLearnedPattern = null)
    {
        $this->newLearnedPattern = $newLearnedPattern;
        return $this;
    }
    /**
     * Get newLearnedPatternPrefix value
     * @return string|null
     */
    public function getNewLearnedPatternPrefix()
    {
        return $this->newLearnedPatternPrefix;
    }
    /**
     * Set newLearnedPatternPrefix value
     * @param string $newLearnedPatternPrefix
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setNewLearnedPatternPrefix($newLearnedPatternPrefix = null)
    {
        $this->newLearnedPatternPrefix = $newLearnedPatternPrefix;
        return $this;
    }
    /**
     * Get newCallControlIdentity value
     * @return string|null
     */
    public function getNewCallControlIdentity()
    {
        return $this->newCallControlIdentity;
    }
    /**
     * Set newCallControlIdentity value
     * @param string $newCallControlIdentity
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setNewCallControlIdentity($newCallControlIdentity = null)
    {
        $this->newCallControlIdentity = $newCallControlIdentity;
        return $this;
    }
    /**
     * Get newIpAddress value
     * @return string|null
     */
    public function getNewIpAddress()
    {
        return $this->newIpAddress;
    }
    /**
     * Set newIpAddress value
     * @param string $newIpAddress
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\UpdateSafCcdPurgeBlockLearnedRoutesReq
     */
    public function setNewIpAddress($newIpAddress = null)
    {
        $this->newIpAddress = $newIpAddress;
        return $this;
    }
}
